JOptionPane (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing, class: JOptionPane
Keywords: javax.swing.JOptionPane class

# Class JOptionPane

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JOptionPane

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible`

@JavaBean(defaultProperty="UI", description="A component which implements standard dialog box controls.") public class JOptionPane extends JComponent implements Accessible
`JOptionPane` makes it easy to pop up a standard dialog box that prompts users for a value or informs them of something. For information about using `JOptionPane`, see How to Make Dialogs, a section in The Java Tutorial.

While the `JOptionPane` class may appear complex because of the large number of methods, almost all uses of this class are one-line calls to one of the static `showXxxDialog` methods shown below:

Common JOptionPane method names and their descriptions
Method Name | Description
--- | ---
showConfirmDialog | Asks a confirming question, like yes/no/cancel.
showInputDialog | Prompt for some input.
showMessageDialog | Tell the user about something that has happened.
showOptionDialog | The Grand Unification of the above three.

Each of these methods also comes in a `showInternalXXX` flavor, which uses an internal frame to hold the dialog box (see `JInternalFrame`). Multiple convenience methods have also been defined -- overloaded versions of the basic methods that use different parameter lists.

All dialogs are modal. Each `showXxxDialog` method blocks the caller until the user's interaction is complete.

Common dialog
icon | message
input value
option buttons

The basic appearance of one of these dialog boxes is generally similar to the picture above, although the various look-and-feels are ultimately responsible for the final result. In particular, the look-and-feels will adjust the layout to accommodate the option pane's `ComponentOrientation` property.

Parameters:
The parameters to these methods follow consistent patterns:

> parentComponent
>   Defines the `Component` that is to be the parent of this dialog box. It is used in two ways: the `Frame` that contains it is used as the `Frame` parent for the dialog box, and its screen coordinates are used in the placement of the dialog box. In general, the dialog box is placed just below the component. This parameter may be `null`, in which case a default `Frame` is used as the parent, and the dialog will be centered on the screen (depending on the L&F).
> message
>   A descriptive message to be placed in the dialog box. In the most common usage, message is just a `String` or `String` constant. However, the type of this parameter is actually `Object`. Its interpretation depends on its type:
>   Object[]
>     An array of objects is interpreted as a series of messages (one per object) arranged in a vertical stack. The interpretation is recursive -- each object in the array is interpreted according to its type.
>   Component
>     The `Component` is displayed in the dialog.
>   Icon
>     The `Icon` is wrapped in a `JLabel` and displayed in the dialog.
>   others
>     The object is converted to a `String` by calling its `toString` method. The result is wrapped in a `JLabel` and displayed.
> messageType
>   Defines the style of the message. The Look and Feel manager may lay out the dialog differently depending on this value, and will often provide a default icon. The possible values are:
>   - `ERROR_MESSAGE`
>   - `INFORMATION_MESSAGE`
>   - `WARNING_MESSAGE`
>   - `QUESTION_MESSAGE`
>   - `PLAIN_MESSAGE`
> optionType
>   Defines the set of option buttons that appear at the bottom of the dialog box:
>   - `DEFAULT_OPTION`
>   - `YES_NO_OPTION`
>   - `YES_NO_CANCEL_OPTION`
>   - `OK_CANCEL_OPTION`
>   You aren't limited to this set of option buttons. You can provide any buttons you want using the options parameter.
> options
>   A more detailed description of the set of option buttons that will appear at the bottom of the dialog box. The usual value for the options parameter is an array of `String`s. But the parameter type is an array of `Objects`. A button is created for each object depending on its type:
>   Component
>     The component is added to the button row directly.
>   Icon
>     A `JButton` is created with this as its label.
>   other
>     The `Object` is converted to a string using its `toString` method and the result is used to label a `JButton`.
> icon
>   A decorative icon to be placed in the dialog box. A default value for this is determined by the `messageType` parameter.
> title
>   The title for the dialog box.
> initialValue
>   The default selection (input value).

When the selection is changed, `setValue` is invoked, which generates a `PropertyChangeEvent`.

If a `JOptionPane` has configured to all input `setWantsInput` the bound property `JOptionPane.INPUT_VALUE_PROPERTY` can also be listened to, to determine when the user has input or selected a value.

When one of the `showXxxDialog` methods returns an integer, the possible values are:

- `YES_OPTION`
- `NO_OPTION`
- `CANCEL_OPTION`
- `OK_OPTION`
- `CLOSED_OPTION`

Examples:

Show an error dialog that displays the message, 'alert':
  `JOptionPane.showMessageDialog(null, "alert", "alert", JOptionPane.ERROR_MESSAGE);`
Show an internal information dialog with the message, 'information':

      JOptionPane.showInternalMessageDialog(frame, "information",
                  "information", JOptionPane.INFORMATION_MESSAGE);

Show an information panel with the options yes/no and message 'choose one':

      JOptionPane.showConfirmDialog(null,
                  "choose one", "choose one", JOptionPane.YES_NO_OPTION);

Show an internal information dialog with the options yes/no/cancel and message 'please choose one' and title information:

      JOptionPane.showInternalConfirmDialog(frame,
                  "please choose one", "information",
                  JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE);

Show a warning dialog with the options OK, CANCEL, title 'Warning', and message 'Click OK to continue':

      Object[] options = { "OK", "CANCEL" };
      JOptionPane.showOptionDialog(null, "Click OK to continue", "Warning",
                  JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
                  null, options, options[0]);

Show a dialog asking the user to type in a String:
  `String inputValue = JOptionPane.showInputDialog("Please input a value");`
Show a dialog asking the user to select a String:

      Object[] possibleValues = { "First", "Second", "Third" };

      Object selectedValue = JOptionPane.showInputDialog(null,
                  "Choose one", "Input",
                  JOptionPane.INFORMATION_MESSAGE, null,
                  possibleValues, possibleValues[0]);

Direct Use:
To create and use an `JOptionPane` directly, the standard pattern is roughly as follows:

        JOptionPane pane = new JOptionPane(arguments);
        pane.set.Xxxx(...); // Configure
        JDialog dialog = pane.createDialog(parentComponent, title);
        dialog.setVisible(true);
        Object selectedValue = pane.getValue();
        if(selectedValue == null)
          return CLOSED_OPTION;
        //If there is not an array of option buttons:
        if(options == null) {
          if(selectedValue instanceof Integer)
             return ((Integer)selectedValue).intValue();
          return CLOSED_OPTION;
        }
        //If there is an array of option buttons:
        for(int counter = 0, maxCounter = options.length;
           counter < maxCounter; counter++) {
           if(options[counter].equals(selectedValue))
           return counter;
        }
        return CLOSED_OPTION;

Warning: Swing is not thread safe. For more information see Swing's Threading Policy.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

Since:
  1.2
See Also:
  - `JInternalFrame`

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `JOptionPane.AccessibleJOptionPane`
  This class implements accessibility support for the `JOptionPane` class.

  ### Nested classes/interfaces declared in class JComponent

  `JComponent.AccessibleJComponent`
  Modifier and Type
  Class
  Description
  `class`
  `JComponent.AccessibleJComponent`
  Inner class of JComponent used to provide default support for accessibility.

  ### Nested classes/interfaces declared in class Container

  `Container.AccessibleAWTContainer`
  Modifier and Type
  Class
  Description
  `protected class`
  `Container.AccessibleAWTContainer`
  Inner class of Container used to provide default support for accessibility.

  ### Nested classes/interfaces declared in class Component

  `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
  Modifier and Type
  Class
  Description
  `protected class`
  `Component.AccessibleAWTComponent`
  Inner class of Component used to provide default support for accessibility.
  `static enum`
  `Component.BaselineResizeBehavior`
  Enumeration of the common ways the baseline of a component can change as the size changes.
  `protected class`
  `Component.BltBufferStrategy`
  Inner class for blitting offscreen surfaces to a component.
  `protected class`
  `Component.FlipBufferStrategy`
  Inner class for flipping buffers on a component.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `CANCEL_OPTION`
  Return value from class method if CANCEL is chosen.
  `static final int`
  `CLOSED_OPTION`
  Return value from class method if user closes window without selecting anything, more than likely this should be treated as either a `CANCEL_OPTION` or `NO_OPTION`.
  `static final int`
  `DEFAULT_OPTION`
  Type meaning Look and Feel should not supply any options -- only use the options from the `JOptionPane`.
  `static final int`
  `ERROR_MESSAGE`
  Used for error messages.
  `protected Icon`
  `icon`
  Icon used in pane.
  `static final String`
  `ICON_PROPERTY`
  Bound property name for `icon`.
  `static final int`
  `INFORMATION_MESSAGE`
  Used for information messages.
  `static final String`
  `INITIAL_SELECTION_VALUE_PROPERTY`
  Bound property name for `initialSelectionValue`.
  `static final String`
  `INITIAL_VALUE_PROPERTY`
  Bound property name for `initialValue`.
  `protected Object`
  `initialSelectionValue`
  Initial value to select in `selectionValues`.
  `protected Object`
  `initialValue`
  Value that should be initially selected in `options`.
  `static final String`
  `INPUT_VALUE_PROPERTY`
  Bound property name for `inputValue`.
  `protected Object`
  `inputValue`
  Value the user has input.
  `protected Object`
  `message`
  Message to display.
  `static final String`
  `MESSAGE_PROPERTY`
  Bound property name for `message`.
  `static final String`
  `MESSAGE_TYPE_PROPERTY`
  Bound property name for `type`.
  `protected int`
  `messageType`
  Message type.
  `static final int`
  `NO_OPTION`
  Return value from class method if NO is chosen.
  `static final int`
  `OK_CANCEL_OPTION`
  Type used for `showConfirmDialog`.
  `static final int`
  `OK_OPTION`
  Return value from class method if OK is chosen.
  `static final String`
  `OPTION_TYPE_PROPERTY`
  Bound property name for `optionType`.
  `protected Object[]`
  `options`
  Options to display to the user.
  `static final String`
  `OPTIONS_PROPERTY`
  Bound property name for `option`.
  `protected int`
  `optionType`
  Option type, one of `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION` or `OK_CANCEL_OPTION`.
  `static final int`
  `PLAIN_MESSAGE`
  No icon is used.
  `static final int`
  `QUESTION_MESSAGE`
  Used for questions.
  `static final String`
  `SELECTION_VALUES_PROPERTY`
  Bound property name for `selectionValues`.
  `protected Object[]`
  `selectionValues`
  Array of values the user can choose from.
  `static final Object`
  `UNINITIALIZED_VALUE`
  Indicates that the user has not yet selected a value.
  `protected Object`
  `value`
  Currently selected value, will be a valid option, or `UNINITIALIZED_VALUE` or `null`.
  `static final String`
  `VALUE_PROPERTY`
  Bound property name for `value`.
  `static final String`
  `WANTS_INPUT_PROPERTY`
  Bound property name for `wantsInput`.
  `protected boolean`
  `wantsInput`
  If true, a UI widget will be provided to the user to get input.
  `static final int`
  `WARNING_MESSAGE`
  Used for warning messages.
  `static final int`
  `YES_NO_CANCEL_OPTION`
  Type used for `showConfirmDialog`.
  `static final int`
  `YES_NO_OPTION`
  Type used for `showConfirmDialog`.
  `static final int`
  `YES_OPTION`
  Return value from class method if YES is chosen.

  ### Fields declared in class JComponent

  `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`
  Modifier and Type
  Field
  Description
  `protected EventListenerList`
  `listenerList`
  A list of event listeners for this component.
  `static final String`
  `TOOL_TIP_TEXT_KEY`
  The comment to display when the cursor is over the component, also known as a "value tip", "flyover help", or "flyover label".
  `protected ComponentUI`
  `ui`
  The look and feel delegate for this component.
  `static final int`
  `UNDEFINED_CONDITION`
  Constant used by some of the APIs to mean that no condition is defined.
  `static final int`
  `WHEN_ANCESTOR_OF_FOCUSED_COMPONENT`
  Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is an ancestor of the focused component or is itself the focused component.
  `static final int`
  `WHEN_FOCUSED`
  Constant used for `registerKeyboardAction` that means that the command should be invoked when the component has the focus.
  `static final int`
  `WHEN_IN_FOCUSED_WINDOW`
  Constant used for `registerKeyboardAction` that means that the command should be invoked when the receiving component is in the window that has the focus or is itself the focused component.

  ### Fields declared in class Component

  `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
  Modifier and Type
  Field
  Description
  `protected AccessibleContext`
  `accessibleContext`
  The `AccessibleContext` associated with this `Component`.
  `static final float`
  `BOTTOM_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY`.
  `static final float`
  `CENTER_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
  `static final float`
  `LEFT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `RIGHT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `TOP_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY()`.

  ### Fields declared in interface ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
  Modifier and Type
  Field
  Description
  `static final int`
  `ABORT`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
  `static final int`
  `ALLBITS`
  This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
  `static final int`
  `ERROR`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
  `static final int`
  `FRAMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
  `static final int`
  `HEIGHT`
  This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
  `static final int`
  `PROPERTIES`
  This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
  `static final int`
  `SOMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
  `static final int`
  `WIDTH`
  This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JOptionPane()`
  Creates a `JOptionPane` with a test message.
  `JOptionPane(Object message)`
  Creates a instance of `JOptionPane` to display a message using the plain-message message type and the default options delivered by the UI.
  `JOptionPane(Object message, int messageType)`
  Creates an instance of `JOptionPane` to display a message with the specified message type and the default options,
  `JOptionPane(Object message, int messageType, int optionType)`
  Creates an instance of `JOptionPane` to display a message with the specified message type and options.
  `JOptionPane(Object message, int messageType, int optionType, Icon icon)`
  Creates an instance of `JOptionPane` to display a message with the specified message type, options, and icon.
  `JOptionPane(Object message, int messageType, int optionType, Icon icon, Object[] options)`
  Creates an instance of `JOptionPane` to display a message with the specified message type, icon, and options.
  `JOptionPane(Object message, int messageType, int optionType, Icon icon, Object[] options, Object initialValue)`
  Creates an instance of `JOptionPane` to display a message with the specified message type, icon, and options, with the initially-selected option specified.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `JDialog`
  `createDialog(Component parentComponent, String title)`
  Creates and returns a new `JDialog` wrapping `this` centered on the `parentComponent` in the `parentComponent`'s frame.
  `JDialog`
  `createDialog(String title)`
  Creates and returns a new parentless `JDialog` with the specified title.
  `JInternalFrame`
  `createInternalFrame(Component parentComponent, String title)`
  Creates and returns an instance of `JInternalFrame`.
  `AccessibleContext`
  `getAccessibleContext()`
  Returns the `AccessibleContext` associated with this JOptionPane.
  `static JDesktopPane`
  `getDesktopPaneForComponent(Component parentComponent)`
  Returns the specified component's desktop pane.
  `static Frame`
  `getFrameForComponent(Component parentComponent)`
  Returns the specified component's `Frame`.
  `Icon`
  `getIcon()`
  Returns the icon this pane displays.
  `Object`
  `getInitialSelectionValue()`
  Returns the input value that is displayed as initially selected to the user.
  `Object`
  `getInitialValue()`
  Returns the initial value.
  `Object`
  `getInputValue()`
  Returns the value the user has input, if `wantsInput` is true.
  `int`
  `getMaxCharactersPerLineCount()`
  Returns the maximum number of characters to place on a line in a message.
  `Object`
  `getMessage()`
  Returns the message-object this pane displays.
  `int`
  `getMessageType()`
  Returns the message type.
  `Object[]`
  `getOptions()`
  Returns the choices the user can make.
  `int`
  `getOptionType()`
  Returns the type of options that are displayed.
  `static Frame`
  `getRootFrame()`
  Returns the `Frame` to use for the class methods in which a frame is not provided.
  `Object[]`
  `getSelectionValues()`
  Returns the input selection values.
  `OptionPaneUI`
  `getUI()`
  Returns the UI object which implements the L&F for this component.
  `String`
  `getUIClassID()`
  Returns the name of the UI class that implements the L&F for this component.
  `Object`
  `getValue()`
  Returns the value the user has selected.
  `boolean`
  `getWantsInput()`
  Returns the value of the `wantsInput` property.
  `protected String`
  `paramString()`
  Returns a string representation of this `JOptionPane`.
  `void`
  `selectInitialValue()`
  Requests that the initial value be selected, which will set focus to the initial value.
  `void`
  `setIcon(Icon newIcon)`
  Sets the icon to display.
  `void`
  `setInitialSelectionValue(Object newValue)`
  Sets the input value that is initially displayed as selected to the user.
  `void`
  `setInitialValue(Object newInitialValue)`
  Sets the initial value that is to be enabled -- the `Component` that has the focus when the pane is initially displayed.
  `void`
  `setInputValue(Object newValue)`
  Sets the input value that was selected or input by the user.
  `void`
  `setMessage(Object newMessage)`
  Sets the option pane's message-object.
  `void`
  `setMessageType(int newType)`
  Sets the option pane's message type.
  `void`
  `setOptions(Object[] newOptions)`
  Sets the options this pane displays.
  `void`
  `setOptionType(int newType)`
  Sets the options to display.
  `static void`
  `setRootFrame(Frame newRootFrame)`
  Sets the frame to use for class methods in which a frame is not provided.
  `void`
  `setSelectionValues(Object[] newValues)`
  Sets the input selection values for a pane that provides the user with a list of items to choose from.
  `void`
  `setUI(OptionPaneUI ui)`
  Sets the UI object which implements the L&F for this component.
  `void`
  `setValue(Object newValue)`
  Sets the value the user has chosen.
  `void`
  `setWantsInput(boolean newValue)`
  Sets the `wantsInput` property.
  `static int`
  `showConfirmDialog(Component parentComponent, Object message)`
  Brings up a dialog with the options Yes, No and Cancel; with the title, Select an Option.
  `static int`
  `showConfirmDialog(Component parentComponent, Object message, String title, int optionType)`
  Brings up a dialog where the number of choices is determined by the `optionType` parameter.
  `static int`
  `showConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType)`
  Brings up a dialog where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display.
  `static int`
  `showConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon)`
  Brings up a dialog with a specified icon, where the number of choices is determined by the `optionType` parameter.
  `static String`
  `showInputDialog(Component parentComponent, Object message)`
  Shows a question-message dialog requesting input from the user parented to `parentComponent`.
  `static String`
  `showInputDialog(Component parentComponent, Object message, Object initialSelectionValue)`
  Shows a question-message dialog requesting input from the user and parented to `parentComponent`.
  `static String`
  `showInputDialog(Component parentComponent, Object message, String title, int messageType)`
  Shows a dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
  `static Object`
  `showInputDialog(Component parentComponent, Object message, String title, int messageType, Icon icon, Object[] selectionValues, Object initialSelectionValue)`
  Prompts the user for input in a blocking dialog where the initial selection, possible selections, and all other options can be specified.
  `static String`
  `showInputDialog(Object message)`
  Shows a question-message dialog requesting input from the user.
  `static String`
  `showInputDialog(Object message, Object initialSelectionValue)`
  Shows a question-message dialog requesting input from the user, with the input value initialized to `initialSelectionValue`.
  `static int`
  `showInternalConfirmDialog(Component parentComponent, Object message)`
  Brings up an internal dialog panel with the options Yes, No and Cancel; with the title, Select an Option.
  `static int`
  `showInternalConfirmDialog(Component parentComponent, Object message, String title, int optionType)`
  Brings up a internal dialog panel where the number of choices is determined by the `optionType` parameter.
  `static int`
  `showInternalConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType)`
  Brings up an internal dialog panel where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display.
  `static int`
  `showInternalConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon)`
  Brings up an internal dialog panel with a specified icon, where the number of choices is determined by the `optionType` parameter.
  `static String`
  `showInternalInputDialog(Component parentComponent, Object message)`
  Shows an internal question-message dialog requesting input from the user parented to `parentComponent`.
  `static String`
  `showInternalInputDialog(Component parentComponent, Object message, String title, int messageType)`
  Shows an internal dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
  `static Object`
  `showInternalInputDialog(Component parentComponent, Object message, String title, int messageType, Icon icon, Object[] selectionValues, Object initialSelectionValue)`
  Prompts the user for input in a blocking internal dialog where the initial selection, possible selections, and all other options can be specified.
  `static void`
  `showInternalMessageDialog(Component parentComponent, Object message)`
  Brings up an internal confirmation dialog panel.
  `static void`
  `showInternalMessageDialog(Component parentComponent, Object message, String title, int messageType)`
  Brings up an internal dialog panel that displays a message using a default icon determined by the `messageType` parameter.
  `static void`
  `showInternalMessageDialog(Component parentComponent, Object message, String title, int messageType, Icon icon)`
  Brings up an internal dialog panel displaying a message, specifying all parameters.
  `static int`
  `showInternalOptionDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon, Object[] options, Object initialValue)`
  Brings up an internal dialog panel with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.
  `static void`
  `showMessageDialog(Component parentComponent, Object message)`
  Brings up an information-message dialog titled "Message".
  `static void`
  `showMessageDialog(Component parentComponent, Object message, String title, int messageType)`
  Brings up a dialog that displays a message using a default icon determined by the `messageType` parameter.
  `static void`
  `showMessageDialog(Component parentComponent, Object message, String title, int messageType, Icon icon)`
  Brings up a dialog displaying a message, specifying all parameters.
  `static int`
  `showOptionDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon, Object[] options, Object initialValue)`
  Brings up a dialog with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.
  `void`
  `updateUI()`
  Notification from the `UIManager` that the L&F has changed.

  ### Methods declared in class JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`
  Modifier and Type
  Method
  Description
  `void`
  `addAncestorListener(AncestorListener listener)`
  Registers `listener` so that it will receive `AncestorEvents` when it or any of its ancestors move or are made visible or invisible.
  `void`
  `addNotify()`
  Notifies this component that it now has a parent component.
  `void`
  `addVetoableChangeListener(VetoableChangeListener listener)`
  Adds a `VetoableChangeListener` to the listener list.
  `void`
  `computeVisibleRect(Rectangle visibleRect)`
  Returns the `Component`'s "visible rect rectangle" - the intersection of the visible rectangles for this component and all of its ancestors.
  `boolean`
  `contains(int x, int y)`
  Gives the UI delegate an opportunity to define the precise shape of this component for the sake of mouse processing.
  `JToolTip`
  `createToolTip()`
  Returns the instance of `JToolTip` that should be used to display the tooltip.
  `void`
  `disable()`
  Deprecated.
  As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
  `void`
  `enable()`
  Deprecated.
  As of JDK version 1.1, replaced by `java.awt.Component.setEnabled(boolean)`.
  `void`
  `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
  Support for reporting bound property changes for boolean properties.
  `void`
  `firePropertyChange(String propertyName, int oldValue, int newValue)`
  Support for reporting bound property changes for integer properties.
  `protected void`
  `fireVetoableChange(String propertyName, Object oldValue, Object newValue)`
  Supports reporting constrained property changes.
  `ActionListener`
  `getActionForKeyStroke(KeyStroke aKeyStroke)`
  Returns the object that will perform the action registered for a given keystroke.
  `final ActionMap`
  `getActionMap()`
  Returns the `ActionMap` used to determine what `Action` to fire for particular `KeyStroke` binding.
  `float`
  `getAlignmentX()`
  Overrides `Container.getAlignmentX` to return the horizontal alignment.
  `float`
  `getAlignmentY()`
  Overrides `Container.getAlignmentY` to return the vertical alignment.
  `AncestorListener[]`
  `getAncestorListeners()`
  Returns an array of all the ancestor listeners registered on this component.
  `boolean`
  `getAutoscrolls()`
  Gets the `autoscrolls` property.
  `int`
  `getBaseline(int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior()`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Border`
  `getBorder()`
  Returns the border of this component or `null` if no border is currently set.
  `Rectangle`
  `getBounds(Rectangle rv)`
  Stores the bounds of this component into "return value" `rv` and returns `rv`.
  `final Object`
  `getClientProperty(Object key)`
  Returns the value of the property with the specified key.
  `protected Graphics`
  `getComponentGraphics(Graphics g)`
  Returns the graphics object used to paint this component.
  `JPopupMenu`
  `getComponentPopupMenu()`
  Returns `JPopupMenu` that assigned for this component.
  `int`
  `getConditionForKeyStroke(KeyStroke aKeyStroke)`
  Returns the condition that determines whether a registered action occurs in response to the specified keystroke.
  `int`
  `getDebugGraphicsOptions()`
  Returns the state of graphics debugging.
  `static Locale`
  `getDefaultLocale()`
  Returns the default locale used to initialize each JComponent's locale property upon creation.
  `FontMetrics`
  `getFontMetrics(Font font)`
  Gets the `FontMetrics` for the specified `Font`.
  `Graphics`
  `getGraphics()`
  Returns this component's graphics context, which lets you draw on a component.
  `int`
  `getHeight()`
  Returns the current height of this component.
  `boolean`
  `getInheritsPopupMenu()`
  Returns true if the JPopupMenu should be inherited from the parent.
  `final InputMap`
  `getInputMap()`
  Returns the `InputMap` that is used when the component has focus.
  `final InputMap`
  `getInputMap(int condition)`
  Returns the `InputMap` that is used during `condition`.
  `InputVerifier`
  `getInputVerifier()`
  Returns the input verifier for this component.
  `Insets`
  `getInsets()`
  If a border has been set on this component, returns the border's insets; otherwise calls `super.getInsets`.
  `Insets`
  `getInsets(Insets insets)`
  Returns an `Insets` object containing this component's inset values.
  `<T extends EventListener>
  T[]`
  `getListeners(Class<T> listenerType)`
  Returns an array of all the objects currently registered as `FooListener`s upon this `JComponent`.
  `Point`
  `getLocation(Point rv)`
  Stores the x,y origin of this component into "return value" `rv` and returns `rv`.
  `Dimension`
  `getMaximumSize()`
  If the maximum size has been set to a non-`null` value just returns it.
  `Dimension`
  `getMinimumSize()`
  If the minimum size has been set to a non-`null` value just returns it.
  `Component`
  `getNextFocusableComponent()`
  Deprecated.
  As of 1.4, replaced by `FocusTraversalPolicy`.
  `Point`
  `getPopupLocation(MouseEvent event)`
  Returns the preferred location to display the popup menu in this component's coordinate system.
  `Dimension`
  `getPreferredSize()`
  If the `preferredSize` has been set to a non-`null` value just returns it.
  `KeyStroke[]`
  `getRegisteredKeyStrokes()`
  Returns the `KeyStrokes` that will initiate registered actions.
  `JRootPane`
  `getRootPane()`
  Returns the `JRootPane` ancestor for this component.
  `Dimension`
  `getSize(Dimension rv)`
  Stores the width/height of this component into "return value" `rv` and returns `rv`.
  `Point`
  `getToolTipLocation(MouseEvent event)`
  Returns the tooltip location in this component's coordinate system.
  `String`
  `getToolTipText()`
  Returns the tooltip string that has been set with `setToolTipText`.
  `String`
  `getToolTipText(MouseEvent event)`
  Returns the string to be used as the tooltip for event.
  `Container`
  `getTopLevelAncestor()`
  Returns the top-level ancestor of this component (the containing `Window`) or `null` if this component has not been added to any container.
  `TransferHandler`
  `getTransferHandler()`
  Gets the `transferHandler` property.
  `boolean`
  `getVerifyInputWhenFocusTarget()`
  Returns the value that indicates whether the input verifier for the current focus owner will be called before this component requests focus.
  `VetoableChangeListener[]`
  `getVetoableChangeListeners()`
  Returns an array of all the vetoable change listeners registered on this component.
  `Rectangle`
  `getVisibleRect()`
  Returns the `Component`'s "visible rectangle" - the intersection of this component's visible rectangle, `new Rectangle(0, 0, getWidth(), getHeight())`, and all of its ancestors' visible rectangles.
  `int`
  `getWidth()`
  Returns the current width of this component.
  `int`
  `getX()`
  Returns the current x coordinate of the component's origin.
  `int`
  `getY()`
  Returns the current y coordinate of the component's origin.
  `void`
  `grabFocus()`
  Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `void`
  `hide()`
  Deprecated.
  `boolean`
  `isDoubleBuffered()`
  Returns whether this component should use a buffer to paint.
  `static boolean`
  `isLightweightComponent(Component c)`
  Returns true if this component is lightweight, that is, if it doesn't have a native window system peer.
  `boolean`
  `isManagingFocus()`
  Deprecated.
  As of 1.4, replaced by `Component.setFocusTraversalKeys(int, Set)` and `Container.setFocusCycleRoot(boolean)`.
  `boolean`
  `isOpaque()`
  Returns true if this component is completely opaque.
  `boolean`
  `isOptimizedDrawingEnabled()`
  Returns true if this component tiles its children -- that is, if it can guarantee that the children will not overlap.
  `final boolean`
  `isPaintingForPrint()`
  Returns `true` if the current painting operation on this component is part of a `print` operation.
  `protected boolean`
  `isPaintingOrigin()`
  Returns `true` if a paint triggered on a child component should cause painting to originate from this Component, or one of its ancestors.
  `boolean`
  `isPaintingTile()`
  Returns true if the component is currently painting a tile.
  `boolean`
  `isRequestFocusEnabled()`
  Returns `true` if this `JComponent` should get focus; otherwise returns `false`.
  `boolean`
  `isValidateRoot()`
  If this method returns true, `revalidate` calls by descendants of this component will cause the entire tree beginning with this root to be validated.
  `void`
  `paint(Graphics g)`
  Invoked by Swing to draw components.
  `protected void`
  `paintBorder(Graphics g)`
  Paints the component's border.
  `protected void`
  `paintChildren(Graphics g)`
  Paints this component's children.
  `protected void`
  `paintComponent(Graphics g)`
  Calls the UI delegate's paint method, if the UI delegate is non-`null`.
  `void`
  `paintImmediately(int x, int y, int w, int h)`
  Paints the specified region in this component and all of its descendants that overlap the region, immediately.
  `void`
  `paintImmediately(Rectangle r)`
  Paints the specified region now.
  `void`
  `print(Graphics g)`
  Invoke this method to print the component to the specified `Graphics`.
  `void`
  `printAll(Graphics g)`
  Invoke this method to print the component.
  `protected void`
  `printBorder(Graphics g)`
  Prints the component's border.
  `protected void`
  `printChildren(Graphics g)`
  Prints this component's children.
  `protected void`
  `printComponent(Graphics g)`
  This is invoked during a printing operation.
  `protected void`
  `processComponentKeyEvent(KeyEvent e)`
  Processes any key events that the component itself recognizes.
  `protected boolean`
  `processKeyBinding(KeyStroke ks, KeyEvent e, int condition, boolean pressed)`
  Invoked to process the key bindings for `ks` as the result of the `KeyEvent` `e`.
  `protected void`
  `processKeyEvent(KeyEvent e)`
  Overrides `processKeyEvent` to process events.
  `protected void`
  `processMouseEvent(MouseEvent e)`
  Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects, refer to `Component.processMouseEvent(MouseEvent)` for a complete description of this method.
  `protected void`
  `processMouseMotionEvent(MouseEvent e)`
  Processes mouse motion events, such as MouseEvent.MOUSE_DRAGGED.
  `final void`
  `putClientProperty(Object key, Object value)`
  Adds an arbitrary key/value "client property" to this component.
  `void`
  `registerKeyboardAction(ActionListener anAction, String aCommand, KeyStroke aKeyStroke, int aCondition)`
  This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
  `void`
  `registerKeyboardAction(ActionListener anAction, KeyStroke aKeyStroke, int aCondition)`
  This method is now obsolete, please use a combination of `getActionMap()` and `getInputMap()` for similar behavior.
  `void`
  `removeAncestorListener(AncestorListener listener)`
  Unregisters `listener` so that it will no longer receive `AncestorEvents`.
  `void`
  `removeNotify()`
  Notifies this component that it no longer has a parent component.
  `void`
  `removeVetoableChangeListener(VetoableChangeListener listener)`
  Removes a `VetoableChangeListener` from the listener list.
  `void`
  `repaint(long tm, int x, int y, int width, int height)`
  Adds the specified region to the dirty region list if the component is showing.
  `void`
  `repaint(Rectangle r)`
  Adds the specified region to the dirty region list if the component is showing.
  `boolean`
  `requestDefaultFocus()`
  Deprecated.
  As of 1.4, replaced by `FocusTraversalPolicy.getDefaultComponent(Container).requestFocus()`
  `void`
  `requestFocus()`
  Requests that this `Component` gets the input focus.
  `boolean`
  `requestFocus(boolean temporary)`
  Requests that this `Component` gets the input focus.
  `boolean`
  `requestFocusInWindow()`
  Requests that this `Component` gets the input focus.
  `protected boolean`
  `requestFocusInWindow(boolean temporary)`
  Requests that this `Component` gets the input focus.
  `void`
  `resetKeyboardActions()`
  Unregisters all the bindings in the first tier `InputMaps` and `ActionMap`.
  `void`
  `reshape(int x, int y, int w, int h)`
  Deprecated.
  As of JDK 5, replaced by `Component.setBounds(int, int, int, int)`.
  `void`
  `revalidate()`
  Supports deferred automatic layout.
  `void`
  `scrollRectToVisible(Rectangle aRect)`
  Forwards the `scrollRectToVisible()` message to the `JComponent`'s parent.
  `final void`
  `setActionMap(ActionMap am)`
  Sets the `ActionMap` to `am`.
  `void`
  `setAlignmentX(float alignmentX)`
  Sets the horizontal alignment.
  `void`
  `setAlignmentY(float alignmentY)`
  Sets the vertical alignment.
  `void`
  `setAutoscrolls(boolean autoscrolls)`
  Sets the `autoscrolls` property.
  `void`
  `setBackground(Color bg)`
  Sets the background color of this component.
  `void`
  `setBorder(Border border)`
  Sets the border of this component.
  `void`
  `setComponentPopupMenu(JPopupMenu popup)`
  Sets the `JPopupMenu` for this `JComponent`.
  `void`
  `setDebugGraphicsOptions(int debugOptions)`
  Enables or disables diagnostic information about every graphics operation performed within the component or one of its children.
  `static void`
  `setDefaultLocale(Locale l)`
  Sets the default locale used to initialize each JComponent's locale property upon creation.
  `void`
  `setDoubleBuffered(boolean aFlag)`
  Sets whether this component should use a buffer to paint.
  `void`
  `setEnabled(boolean enabled)`
  Sets whether or not this component is enabled.
  `void`
  `setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
  Sets the focus traversal keys for a given traversal operation for this Component.
  `void`
  `setFont(Font font)`
  Sets the font for this component.
  `void`
  `setForeground(Color fg)`
  Sets the foreground color of this component.
  `void`
  `setInheritsPopupMenu(boolean value)`
  Sets whether or not `getComponentPopupMenu` should delegate to the parent if this component does not have a `JPopupMenu` assigned to it.
  `final void`
  `setInputMap(int condition, InputMap map)`
  Sets the `InputMap` to use under the condition `condition` to `map`.
  `void`
  `setInputVerifier(InputVerifier inputVerifier)`
  Sets the input verifier for this component.
  `void`
  `setMaximumSize(Dimension maximumSize)`
  Sets the maximum size of this component to a constant value.
  `void`
  `setMinimumSize(Dimension minimumSize)`
  Sets the minimum size of this component to a constant value.
  `void`
  `setNextFocusableComponent(Component aComponent)`
  Deprecated.
  As of 1.4, replaced by `FocusTraversalPolicy`
  `void`
  `setOpaque(boolean isOpaque)`
  If true the component paints every pixel within its bounds.
  `void`
  `setPreferredSize(Dimension preferredSize)`
  Sets the preferred size of this component.
  `void`
  `setRequestFocusEnabled(boolean requestFocusEnabled)`
  Provides a hint as to whether or not this `JComponent` should get focus.
  `void`
  `setToolTipText(String text)`
  Registers the text to display in a tool tip.
  `void`
  `setTransferHandler(TransferHandler newHandler)`
  Sets the `TransferHandler`, which provides support for transfer of data into and out of this component via cut/copy/paste and drag and drop.
  `protected void`
  `setUI(ComponentUI newUI)`
  Sets the look and feel delegate for this component.
  `void`
  `setVerifyInputWhenFocusTarget(boolean verifyInputWhenFocusTarget)`
  Sets the value to indicate whether input verifier for the current focus owner will be called before this component requests focus.
  `void`
  `setVisible(boolean aFlag)`
  Makes the component visible or invisible.
  `void`
  `unregisterKeyboardAction(KeyStroke aKeyStroke)`
  This method is now obsolete.
  `void`
  `update(Graphics g)`
  Calls `paint`.

  ### Methods declared in class Container

  `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`
  Modifier and Type
  Method
  Description
  `Component`
  `add(Component comp)`
  Appends the specified component to the end of this container.
  `Component`
  `add(Component comp, int index)`
  Adds the specified component to this container at the given position.
  `void`
  `add(Component comp, Object constraints)`
  Adds the specified component to the end of this container.
  `void`
  `add(Component comp, Object constraints, int index)`
  Adds the specified component to this container with the specified constraints at the specified index.
  `Component`
  `add(String name, Component comp)`
  Adds the specified component to this container.
  `void`
  `addContainerListener(ContainerListener l)`
  Adds the specified container listener to receive container events from this container.
  `protected void`
  `addImpl(Component comp, Object constraints, int index)`
  Adds the specified component to this container at the specified index.
  `void`
  `addPropertyChangeListener(PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list.
  `void`
  `addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list for a specific property.
  `void`
  `applyComponentOrientation(ComponentOrientation o)`
  Sets the `ComponentOrientation` property of this container and all components contained within it.
  `boolean`
  `areFocusTraversalKeysSet(int id)`
  Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Container.
  `int`
  `countComponents()`
  Deprecated.
  As of JDK version 1.1, replaced by getComponentCount().
  `void`
  `deliverEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`
  `void`
  `doLayout()`
  Causes this container to lay out its components.
  `Component`
  `findComponentAt(int x, int y)`
  Locates the visible child component that contains the specified position.
  `Component`
  `findComponentAt(Point p)`
  Locates the visible child component that contains the specified point.
  `Component`
  `getComponent(int n)`
  Gets the nth component in this container.
  `Component`
  `getComponentAt(int x, int y)`
  Locates the component that contains the x,y position.
  `Component`
  `getComponentAt(Point p)`
  Gets the component that contains the specified point.
  `int`
  `getComponentCount()`
  Gets the number of components in this panel.
  `Component[]`
  `getComponents()`
  Gets all the components in this container.
  `int`
  `getComponentZOrder(Component comp)`
  Returns the z-order index of the component inside the container.
  `ContainerListener[]`
  `getContainerListeners()`
  Returns an array of all the container listeners registered on this container.
  `Set<AWTKeyStroke>`
  `getFocusTraversalKeys(int id)`
  Returns the Set of focus traversal keys for a given traversal operation for this Container.
  `FocusTraversalPolicy`
  `getFocusTraversalPolicy()`
  Returns the focus traversal policy that will manage keyboard traversal of this Container's children, or null if this Container is not a focus cycle root.
  `LayoutManager`
  `getLayout()`
  Gets the layout manager for this container.
  `Point`
  `getMousePosition(boolean allowChildren)`
  Returns the position of the mouse pointer in this `Container`'s coordinate space if the `Container` is under the mouse pointer, otherwise returns `null`.
  `Insets`
  `insets()`
  Deprecated.
  As of JDK version 1.1, replaced by `getInsets()`.
  `void`
  `invalidate()`
  Invalidates the container.
  `boolean`
  `isAncestorOf(Component c)`
  Checks if the component is contained in the component hierarchy of this container.
  `boolean`
  `isFocusCycleRoot()`
  Returns whether this Container is the root of a focus traversal cycle.
  `boolean`
  `isFocusCycleRoot(Container container)`
  Returns whether the specified Container is the focus cycle root of this Container's focus traversal cycle.
  `final boolean`
  `isFocusTraversalPolicyProvider()`
  Returns whether this container provides focus traversal policy.
  `boolean`
  `isFocusTraversalPolicySet()`
  Returns whether the focus traversal policy has been explicitly set for this Container.
  `void`
  `layout()`
  Deprecated.
  As of JDK version 1.1, replaced by `doLayout()`.
  `void`
  `list(PrintStream out, int indent)`
  Prints a listing of this container to the specified output stream.
  `void`
  `list(PrintWriter out, int indent)`
  Prints out a list, starting at the specified indentation, to the specified print writer.
  `Component`
  `locate(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by `getComponentAt(int, int)`.
  `Dimension`
  `minimumSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getMinimumSize()`.
  `void`
  `paintComponents(Graphics g)`
  Paints each of the components in this container.
  `Dimension`
  `preferredSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getPreferredSize()`.
  `void`
  `printComponents(Graphics g)`
  Prints each of the components in this container.
  `protected void`
  `processContainerEvent(ContainerEvent e)`
  Processes container events occurring on this container by dispatching them to any registered ContainerListener objects.
  `protected void`
  `processEvent(AWTEvent e)`
  Processes events on this container.
  `void`
  `remove(int index)`
  Removes the component, specified by `index`, from this container.
  `void`
  `remove(Component comp)`
  Removes the specified component from this container.
  `void`
  `removeAll()`
  Removes all the components from this container.
  `void`
  `removeContainerListener(ContainerListener l)`
  Removes the specified container listener so it no longer receives container events from this container.
  `void`
  `setComponentZOrder(Component comp, int index)`
  Moves the specified component to the specified z-order index in the container.
  `void`
  `setFocusCycleRoot(boolean focusCycleRoot)`
  Sets whether this Container is the root of a focus traversal cycle.
  `void`
  `setFocusTraversalPolicy(FocusTraversalPolicy policy)`
  Sets the focus traversal policy that will manage keyboard traversal of this Container's children, if this Container is a focus cycle root.
  `final void`
  `setFocusTraversalPolicyProvider(boolean provider)`
  Sets whether this container will be used to provide focus traversal policy.
  `void`
  `setLayout(LayoutManager mgr)`
  Sets the layout manager for this container.
  `void`
  `transferFocusDownCycle()`
  Transfers the focus down one focus traversal cycle.
  `void`
  `validate()`
  Validates this container and all of its subcomponents.
  `protected void`
  `validateTree()`
  Recursively descends the container tree and recomputes the layout for any subtrees marked as needing it (those marked as invalid).

  ### Methods declared in class Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`
  Modifier and Type
  Method
  Description
  `boolean`
  `action(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
  `void`
  `add(PopupMenu popup)`
  Adds the specified popup menu to the component.
  `void`
  `addComponentListener(ComponentListener l)`
  Adds the specified component listener to receive component events from this component.
  `void`
  `addFocusListener(FocusListener l)`
  Adds the specified focus listener to receive focus events from this component when this component gains input focus.
  `void`
  `addHierarchyBoundsListener(HierarchyBoundsListener l)`
  Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addHierarchyListener(HierarchyListener l)`
  Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addInputMethodListener(InputMethodListener l)`
  Adds the specified input method listener to receive input method events from this component.
  `void`
  `addKeyListener(KeyListener l)`
  Adds the specified key listener to receive key events from this component.
  `void`
  `addMouseListener(MouseListener l)`
  Adds the specified mouse listener to receive mouse events from this component.
  `void`
  `addMouseMotionListener(MouseMotionListener l)`
  Adds the specified mouse motion listener to receive mouse motion events from this component.
  `void`
  `addMouseWheelListener(MouseWheelListener l)`
  Adds the specified mouse wheel listener to receive mouse wheel events from this component.
  `Rectangle`
  `bounds()`
  Deprecated.
  As of JDK version 1.1, replaced by `getBounds()`.
  `int`
  `checkImage(Image image, int width, int height, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `int`
  `checkImage(Image image, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `protected AWTEvent`
  `coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
  Potentially coalesce an event being posted with an existing event.
  `boolean`
  `contains(Point p)`
  Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
  `Image`
  `createImage(int width, int height)`
  Creates an off-screen drawable image to be used for double buffering.
  `Image`
  `createImage(ImageProducer producer)`
  Creates an image from the specified image producer.
  `VolatileImage`
  `createVolatileImage(int width, int height)`
  Creates a volatile off-screen drawable image to be used for double buffering.
  `VolatileImage`
  `createVolatileImage(int width, int height, ImageCapabilities caps)`
  Creates a volatile off-screen drawable image, with the given capabilities.
  `protected final void`
  `disableEvents(long eventsToDisable)`
  Disables the events defined by the specified event mask parameter from being delivered to this component.
  `final void`
  `dispatchEvent(AWTEvent e)`
  Dispatches an event to this component or one of its sub components.
  `void`
  `enable(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `protected final void`
  `enableEvents(long eventsToEnable)`
  Enables the events defined by the specified event mask parameter to be delivered to this component.
  `void`
  `enableInputMethods(boolean enable)`
  Enables or disables input method support for this component.
  `void`
  `firePropertyChange(String propertyName, byte oldValue, byte newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, char oldValue, char newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, double oldValue, double newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, float oldValue, float newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, long oldValue, long newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, short oldValue, short newValue)`
  Reports a bound property change.
  `protected void`
  `firePropertyChange(String propertyName, Object oldValue, Object newValue)`
  Support for reporting bound property changes for Object properties.
  `Color`
  `getBackground()`
  Gets the background color of this component.
  `Rectangle`
  `getBounds()`
  Gets the bounds of this component in the form of a `Rectangle` object.
  `ColorModel`
  `getColorModel()`
  Gets the instance of `ColorModel` used to display the component on the output device.
  `ComponentListener[]`
  `getComponentListeners()`
  Returns an array of all the component listeners registered on this component.
  `ComponentOrientation`
  `getComponentOrientation()`
  Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
  `Cursor`
  `getCursor()`
  Gets the cursor set in the component.
  `DropTarget`
  `getDropTarget()`
  Gets the `DropTarget` associated with this `Component`.
  `Container`
  `getFocusCycleRootAncestor()`
  Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
  `FocusListener[]`
  `getFocusListeners()`
  Returns an array of all the focus listeners registered on this component.
  `boolean`
  `getFocusTraversalKeysEnabled()`
  Returns whether focus traversal keys are enabled for this Component.
  `Font`
  `getFont()`
  Gets the font of this component.
  `Color`
  `getForeground()`
  Gets the foreground color of this component.
  `GraphicsConfiguration`
  `getGraphicsConfiguration()`
  Gets the `GraphicsConfiguration` associated with this `Component`.
  `HierarchyBoundsListener[]`
  `getHierarchyBoundsListeners()`
  Returns an array of all the hierarchy bounds listeners registered on this component.
  `HierarchyListener[]`
  `getHierarchyListeners()`
  Returns an array of all the hierarchy listeners registered on this component.
  `boolean`
  `getIgnoreRepaint()`
  Returns whether or not paint messages received from the operating system should be ignored.
  `InputContext`
  `getInputContext()`
  Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
  `InputMethodListener[]`
  `getInputMethodListeners()`
  Returns an array of all the input method listeners registered on this component.
  `InputMethodRequests`
  `getInputMethodRequests()`
  Gets the input method request handler which supports requests from input methods for this component.
  `KeyListener[]`
  `getKeyListeners()`
  Returns an array of all the key listeners registered on this component.
  `Locale`
  `getLocale()`
  Gets the locale of this component.
  `Point`
  `getLocation()`
  Gets the location of this component in the form of a point specifying the component's top-left corner.
  `Point`
  `getLocationOnScreen()`
  Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
  `MouseListener[]`
  `getMouseListeners()`
  Returns an array of all the mouse listeners registered on this component.
  `MouseMotionListener[]`
  `getMouseMotionListeners()`
  Returns an array of all the mouse motion listeners registered on this component.
  `Point`
  `getMousePosition()`
  Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
  `MouseWheelListener[]`
  `getMouseWheelListeners()`
  Returns an array of all the mouse wheel listeners registered on this component.
  `String`
  `getName()`
  Gets the name of the component.
  `Container`
  `getParent()`
  Gets the parent of this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners()`
  Returns an array of all the property change listeners registered on this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners(String propertyName)`
  Returns an array of all the listeners which have been associated with the named property.
  `Dimension`
  `getSize()`
  Returns the size of this component in the form of a `Dimension` object.
  `Toolkit`
  `getToolkit()`
  Gets the toolkit of this component.
  `final Object`
  `getTreeLock()`
  Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
  `boolean`
  `gotFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `handleEvent(Event evt)`
  Deprecated.
  As of JDK version 1.1 replaced by processEvent(AWTEvent).
  `boolean`
  `hasFocus()`
  Returns `true` if this `Component` is the focus owner.
  `boolean`
  `imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
  Repaints the component when the image has changed.
  `boolean`
  `inside(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by contains(int, int).
  `boolean`
  `isBackgroundSet()`
  Returns whether the background color has been explicitly set for this Component.
  `boolean`
  `isCursorSet()`
  Returns whether the cursor has been explicitly set for this Component.
  `boolean`
  `isDisplayable()`
  Determines whether this component is displayable.
  `boolean`
  `isEnabled()`
  Determines whether this component is enabled.
  `boolean`
  `isFocusable()`
  Returns whether this Component can be focused.
  `boolean`
  `isFocusOwner()`
  Returns `true` if this `Component` is the focus owner.
  `boolean`
  `isFocusTraversable()`
  Deprecated.
  As of 1.4, replaced by `isFocusable()`.
  `boolean`
  `isFontSet()`
  Returns whether the font has been explicitly set for this Component.
  `boolean`
  `isForegroundSet()`
  Returns whether the foreground color has been explicitly set for this Component.
  `boolean`
  `isLightweight()`
  A lightweight component doesn't have a native toolkit peer.
  `boolean`
  `isMaximumSizeSet()`
  Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isMinimumSizeSet()`
  Returns whether or not `setMinimumSize` has been invoked with a non-null value.
  `boolean`
  `isPreferredSizeSet()`
  Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isShowing()`
  Determines whether this component is showing on screen.
  `boolean`
  `isValid()`
  Determines whether this component is valid.
  `boolean`
  `isVisible()`
  Determines whether this component should be visible when its parent is visible.
  `boolean`
  `keyDown(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `boolean`
  `keyUp(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `void`
  `list()`
  Prints a listing of this component to the standard system output stream `System.out`.
  `void`
  `list(PrintStream out)`
  Prints a listing of this component to the specified output stream.
  `void`
  `list(PrintWriter out)`
  Prints a listing to the specified print writer.
  `Point`
  `location()`
  Deprecated.
  As of JDK version 1.1, replaced by `getLocation()`.
  `boolean`
  `lostFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `mouseDown(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseDrag(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseEnter(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseExit(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseMove(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseUp(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `void`
  `move(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by `setLocation(int, int)`.
  `void`
  `nextFocus()`
  Deprecated.
  As of JDK version 1.1, replaced by transferFocus().
  `void`
  `paintAll(Graphics g)`
  Paints this component and all of its subcomponents.
  `boolean`
  `postEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
  `boolean`
  `prepareImage(Image image, int width, int height, ImageObserver observer)`
  Prepares an image for rendering on this component at the specified width and height.
  `boolean`
  `prepareImage(Image image, ImageObserver observer)`
  Prepares an image for rendering on this component.
  `protected void`
  `processComponentEvent(ComponentEvent e)`
  Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
  `protected void`
  `processFocusEvent(FocusEvent e)`
  Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
  `protected void`
  `processHierarchyBoundsEvent(HierarchyEvent e)`
  Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
  `protected void`
  `processHierarchyEvent(HierarchyEvent e)`
  Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
  `protected void`
  `processInputMethodEvent(InputMethodEvent e)`
  Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
  `protected void`
  `processMouseWheelEvent(MouseWheelEvent e)`
  Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
  `void`
  `remove(MenuComponent popup)`
  Removes the specified popup menu from the component.
  `void`
  `removeComponentListener(ComponentListener l)`
  Removes the specified component listener so that it no longer receives component events from this component.
  `void`
  `removeFocusListener(FocusListener l)`
  Removes the specified focus listener so that it no longer receives focus events from this component.
  `void`
  `removeHierarchyBoundsListener(HierarchyBoundsListener l)`
  Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
  `void`
  `removeHierarchyListener(HierarchyListener l)`
  Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
  `void`
  `removeInputMethodListener(InputMethodListener l)`
  Removes the specified input method listener so that it no longer receives input method events from this component.
  `void`
  `removeKeyListener(KeyListener l)`
  Removes the specified key listener so that it no longer receives key events from this component.
  `void`
  `removeMouseListener(MouseListener l)`
  Removes the specified mouse listener so that it no longer receives mouse events from this component.
  `void`
  `removeMouseMotionListener(MouseMotionListener l)`
  Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
  `void`
  `removeMouseWheelListener(MouseWheelListener l)`
  Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
  `void`
  `removePropertyChangeListener(PropertyChangeListener listener)`
  Removes a PropertyChangeListener from the listener list.
  `void`
  `removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Removes a `PropertyChangeListener` from the listener list for a specific property.
  `void`
  `repaint()`
  Repaints this component.
  `void`
  `repaint(int x, int y, int width, int height)`
  Repaints the specified rectangle of this component.
  `void`
  `repaint(long tm)`
  Repaints the component.
  `protected boolean`
  `requestFocus(boolean temporary, FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
  `void`
  `requestFocus(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `boolean`
  `requestFocusInWindow(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
  `void`
  `resize(int width, int height)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(int, int)`.
  `void`
  `resize(Dimension d)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(Dimension)`.
  `void`
  `setBounds(int x, int y, int width, int height)`
  Moves and resizes this component.
  `void`
  `setBounds(Rectangle r)`
  Moves and resizes this component to conform to the new bounding rectangle `r`.
  `void`
  `setComponentOrientation(ComponentOrientation o)`
  Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
  `void`
  `setCursor(Cursor cursor)`
  Sets the cursor image to the specified cursor.
  `void`
  `setDropTarget(DropTarget dt)`
  Associate a `DropTarget` with this component.
  `void`
  `setFocusable(boolean focusable)`
  Sets the focusable state of this Component to the specified value.
  `void`
  `setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
  Sets whether focus traversal keys are enabled for this Component.
  `void`
  `setIgnoreRepaint(boolean ignoreRepaint)`
  Sets whether or not paint messages received from the operating system should be ignored.
  `void`
  `setLocale(Locale l)`
  Sets the locale of this component.
  `void`
  `setLocation(int x, int y)`
  Moves this component to a new location.
  `void`
  `setLocation(Point p)`
  Moves this component to a new location.
  `void`
  `setMixingCutoutShape(Shape shape)`
  Sets a 'mixing-cutout' shape for this lightweight component.
  `void`
  `setName(String name)`
  Sets the name of the component to the specified string.
  `void`
  `setSize(int width, int height)`
  Resizes this component so that it has width `width` and height `height`.
  `void`
  `setSize(Dimension d)`
  Resizes this component so that it has width `d.width` and height `d.height`.
  `void`
  `show()`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `void`
  `show(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `Dimension`
  `size()`
  Deprecated.
  As of JDK version 1.1, replaced by `getSize()`.
  `String`
  `toString()`
  Returns a string representation of this component and its values.
  `void`
  `transferFocus()`
  Transfers the focus to the next component, as though this Component were the focus owner.
  `void`
  `transferFocusBackward()`
  Transfers the focus to the previous component, as though this Component were the focus owner.
  `void`
  `transferFocusUpCycle()`
  Transfers the focus up one focus traversal cycle.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### UNINITIALIZED_VALUE

    public static final Object UNINITIALIZED_VALUE
    Indicates that the user has not yet selected a value.

  - ### DEFAULT_OPTION

    public static final int DEFAULT_OPTION
    Type meaning Look and Feel should not supply any options -- only use the options from the `JOptionPane`.
    See Also:
      - Constant Field Values

  - ### YES_NO_OPTION

    public static final int YES_NO_OPTION
    Type used for `showConfirmDialog`.
    See Also:
      - Constant Field Values

  - ### YES_NO_CANCEL_OPTION

    public static final int YES_NO_CANCEL_OPTION
    Type used for `showConfirmDialog`.
    See Also:
      - Constant Field Values

  - ### OK_CANCEL_OPTION

    public static final int OK_CANCEL_OPTION
    Type used for `showConfirmDialog`.
    See Also:
      - Constant Field Values

  - ### YES_OPTION

    public static final int YES_OPTION
    Return value from class method if YES is chosen.
    See Also:
      - Constant Field Values

  - ### NO_OPTION

    public static final int NO_OPTION
    Return value from class method if NO is chosen.
    See Also:
      - Constant Field Values

  - ### CANCEL_OPTION

    public static final int CANCEL_OPTION
    Return value from class method if CANCEL is chosen.
    See Also:
      - Constant Field Values

  - ### OK_OPTION

    public static final int OK_OPTION
    Return value from class method if OK is chosen.
    See Also:
      - Constant Field Values

  - ### CLOSED_OPTION

    public static final int CLOSED_OPTION
    Return value from class method if user closes window without selecting anything, more than likely this should be treated as either a `CANCEL_OPTION` or `NO_OPTION`.
    See Also:
      - Constant Field Values

  - ### ERROR_MESSAGE

    public static final int ERROR_MESSAGE
    Used for error messages.
    See Also:
      - Constant Field Values

  - ### INFORMATION_MESSAGE

    public static final int INFORMATION_MESSAGE
    Used for information messages.
    See Also:
      - Constant Field Values

  - ### WARNING_MESSAGE

    public static final int WARNING_MESSAGE
    Used for warning messages.
    See Also:
      - Constant Field Values

  - ### QUESTION_MESSAGE

    public static final int QUESTION_MESSAGE
    Used for questions.
    See Also:
      - Constant Field Values

  - ### PLAIN_MESSAGE

    public static final int PLAIN_MESSAGE
    No icon is used.
    See Also:
      - Constant Field Values

  - ### ICON_PROPERTY

    public static final String ICON_PROPERTY
    Bound property name for `icon`.
    See Also:
      - Constant Field Values

  - ### MESSAGE_PROPERTY

    public static final String MESSAGE_PROPERTY
    Bound property name for `message`.
    See Also:
      - Constant Field Values

  - ### VALUE_PROPERTY

    public static final String VALUE_PROPERTY
    Bound property name for `value`.
    See Also:
      - Constant Field Values

  - ### OPTIONS_PROPERTY

    public static final String OPTIONS_PROPERTY
    Bound property name for `option`.
    See Also:
      - Constant Field Values

  - ### INITIAL_VALUE_PROPERTY

    public static final String INITIAL_VALUE_PROPERTY
    Bound property name for `initialValue`.
    See Also:
      - Constant Field Values

  - ### MESSAGE_TYPE_PROPERTY

    public static final String MESSAGE_TYPE_PROPERTY
    Bound property name for `type`.
    See Also:
      - Constant Field Values

  - ### OPTION_TYPE_PROPERTY

    public static final String OPTION_TYPE_PROPERTY
    Bound property name for `optionType`.
    See Also:
      - Constant Field Values

  - ### SELECTION_VALUES_PROPERTY

    public static final String SELECTION_VALUES_PROPERTY
    Bound property name for `selectionValues`.
    See Also:
      - Constant Field Values

  - ### INITIAL_SELECTION_VALUE_PROPERTY

    public static final String INITIAL_SELECTION_VALUE_PROPERTY
    Bound property name for `initialSelectionValue`.
    See Also:
      - Constant Field Values

  - ### INPUT_VALUE_PROPERTY

    public static final String INPUT_VALUE_PROPERTY
    Bound property name for `inputValue`.
    See Also:
      - Constant Field Values

  - ### WANTS_INPUT_PROPERTY

    public static final String WANTS_INPUT_PROPERTY
    Bound property name for `wantsInput`.
    See Also:
      - Constant Field Values

  - ### icon

    protected transient Icon icon
    Icon used in pane.

  - ### message

    protected transient Object message
    Message to display.

  - ### options

    protected transient Object[] options
    Options to display to the user.

  - ### initialValue

    protected transient Object initialValue
    Value that should be initially selected in `options`.

  - ### messageType

    protected int messageType
    Message type.

  - ### optionType

    protected int optionType
    Option type, one of `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION` or `OK_CANCEL_OPTION`.

  - ### value

    protected transient Object value
    Currently selected value, will be a valid option, or `UNINITIALIZED_VALUE` or `null`.

  - ### selectionValues

    protected transient Object[] selectionValues
    Array of values the user can choose from. Look and feel will provide the UI component to choose this from.

  - ### inputValue

    protected transient Object inputValue
    Value the user has input.

  - ### initialSelectionValue

    protected transient Object initialSelectionValue
    Initial value to select in `selectionValues`.

  - ### wantsInput

    protected boolean wantsInput
    If true, a UI widget will be provided to the user to get input.

- ## Constructor Details

  - ### JOptionPane

    public JOptionPane()
    Creates a `JOptionPane` with a test message.

  - ### JOptionPane

    public JOptionPane(Object message)
    Creates a instance of `JOptionPane` to display a message using the plain-message message type and the default options delivered by the UI.
    Parameters:
      `message` - the `Object` to display

  - ### JOptionPane

    public JOptionPane(Object message, int messageType)
    Creates an instance of `JOptionPane` to display a message with the specified message type and the default options,
    Parameters:
      `message` - the `Object` to display
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`

  - ### JOptionPane

    public JOptionPane(Object message, int messageType, int optionType)
    Creates an instance of `JOptionPane` to display a message with the specified message type and options.
    Parameters:
      `message` - the `Object` to display
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `optionType` - the options to display in the pane: `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, `OK_CANCEL_OPTION`

  - ### JOptionPane

    public JOptionPane(Object message, int messageType, int optionType, Icon icon)
    Creates an instance of `JOptionPane` to display a message with the specified message type, options, and icon.
    Parameters:
      `message` - the `Object` to display
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `optionType` - the options to display in the pane: `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, `OK_CANCEL_OPTION`
      `icon` - the `Icon` image to display

  - ### JOptionPane

    public JOptionPane(Object message, int messageType, int optionType, Icon icon, Object[] options)
    Creates an instance of `JOptionPane` to display a message with the specified message type, icon, and options. None of the options is initially selected.

    The options objects should contain either instances of `Component`s, (which are added directly) or `Strings` (which are wrapped in a `JButton`). If you provide `Component`s, you must ensure that when the `Component` is clicked it messages `setValue` in the created `JOptionPane`.

    Parameters:
      `message` - the `Object` to display
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `optionType` - the options to display in the pane: `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, `OK_CANCEL_OPTION`
      `icon` - the `Icon` image to display
      `options` - the choices the user can select

  - ### JOptionPane

    public JOptionPane(Object message, int messageType, int optionType, Icon icon, Object[] options, Object initialValue)
    Creates an instance of `JOptionPane` to display a message with the specified message type, icon, and options, with the initially-selected option specified.
    Parameters:
      `message` - the `Object` to display
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `optionType` - the options to display in the pane: `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, `OK_CANCEL_OPTION`
      `icon` - the Icon image to display
      `options` - the choices the user can select
      `initialValue` - the choice that is initially selected; if `null`, then nothing will be initially selected; only meaningful if `options` is used

- ## Method Details

  - ### showInputDialog

    public static String showInputDialog(Object message) throws HeadlessException
    Shows a question-message dialog requesting input from the user. The dialog uses the default frame, which usually means it is centered on the screen.
    Parameters:
      `message` - the `Object` to display
    Returns:
      user's input
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showInputDialog

    public static String showInputDialog(Object message, Object initialSelectionValue)
    Shows a question-message dialog requesting input from the user, with the input value initialized to `initialSelectionValue`. The dialog uses the default frame, which usually means it is centered on the screen.
    Parameters:
      `message` - the `Object` to display
      `initialSelectionValue` - the value used to initialize the input field
    Returns:
      user's input
    Since:
      1.4

  - ### showInputDialog

    public static String showInputDialog(Component parentComponent, Object message) throws HeadlessException
    Shows a question-message dialog requesting input from the user parented to `parentComponent`. The dialog is displayed on top of the `Component`'s frame, and is usually positioned below the `Component`.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
    Returns:
      user's input
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showInputDialog

    public static String showInputDialog(Component parentComponent, Object message, Object initialSelectionValue)
    Shows a question-message dialog requesting input from the user and parented to `parentComponent`. The input value will be initialized to `initialSelectionValue`. The dialog is displayed on top of the `Component`'s frame, and is usually positioned below the `Component`.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
      `initialSelectionValue` - the value used to initialize the input field
    Returns:
      user's input
    Since:
      1.4

  - ### showInputDialog

    public static String showInputDialog(Component parentComponent, Object message, String title, int messageType) throws HeadlessException
    Shows a dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
      `title` - the `String` to display in the dialog title bar
      `messageType` - the type of message that is to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    Returns:
      user's input
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showInputDialog

    public static Object showInputDialog(Component parentComponent, Object message, String title, int messageType, Icon icon, Object[] selectionValues, Object initialSelectionValue) throws HeadlessException
    Prompts the user for input in a blocking dialog where the initial selection, possible selections, and all other options can be specified. The user will able to choose from `selectionValues`, where `null` implies the user can input whatever they wish, usually by means of a `JTextField`. `initialSelectionValue` is the initial value to prompt the user with. It is up to the UI to decide how best to represent the `selectionValues`, but usually a `JComboBox`, `JList`, or `JTextField` will be used.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
      `title` - the `String` to display in the dialog title bar
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - the `Icon` image to display
      `selectionValues` - an array of `Object`s that gives the possible selections
      `initialSelectionValue` - the value used to initialize the input field
    Returns:
      user's input, or `null` meaning the user canceled the input
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showMessageDialog

    public static void showMessageDialog(Component parentComponent, Object message) throws HeadlessException
    Brings up an information-message dialog titled "Message".
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showMessageDialog

    public static void showMessageDialog(Component parentComponent, Object message, String title, int messageType) throws HeadlessException
    Brings up a dialog that displays a message using a default icon determined by the `messageType` parameter.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showMessageDialog

    public static void showMessageDialog(Component parentComponent, Object message, String title, int messageType, Icon icon) throws HeadlessException
    Brings up a dialog displaying a message, specifying all parameters.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - an icon to display in the dialog that helps the user identify the kind of message that is being displayed
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showConfirmDialog

    public static int showConfirmDialog(Component parentComponent, Object message) throws HeadlessException
    Brings up a dialog with the options Yes, No and Cancel; with the title, Select an Option.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
    Returns:
      an integer indicating the option selected by the user
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showConfirmDialog

    public static int showConfirmDialog(Component parentComponent, Object message, String title, int optionType) throws HeadlessException
    Brings up a dialog where the number of choices is determined by the `optionType` parameter.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `optionType` - an int designating the options available on the dialog: `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, or `OK_CANCEL_OPTION`
    Returns:
      an int indicating the option selected by the user
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showConfirmDialog

    public static int showConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType) throws HeadlessException
    Brings up a dialog where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display. The `messageType` parameter is primarily used to supply a default icon from the Look and Feel.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used.
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, or `OK_CANCEL_OPTION`
      `messageType` - an integer designating the kind of message this is; primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    Returns:
      an integer indicating the option selected by the user
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showConfirmDialog

    public static int showConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon) throws HeadlessException
    Brings up a dialog with a specified icon, where the number of choices is determined by the `optionType` parameter. The `messageType` parameter is primarily used to supply a default icon from the look and feel.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the Object to display
      `title` - the title string for the dialog
      `optionType` - an int designating the options available on the dialog: `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, or `OK_CANCEL_OPTION`
      `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - the icon to display in the dialog
    Returns:
      an int indicating the option selected by the user
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showOptionDialog

    public static int showOptionDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon, Object[] options, Object initialValue) throws HeadlessException
    Brings up a dialog with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

    If `optionType` is `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION` and the `options` parameter is `null`, then the options are supplied by the look and feel.

    The `messageType` parameter is primarily used to supply a default icon from the look and feel.

    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `optionType` - an integer designating the options available on the dialog: `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, or `OK_CANCEL_OPTION`
      `messageType` - an integer designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - the icon to display in the dialog
      `options` - an array of objects indicating the possible choices the user can make; if the objects are components, they are rendered properly; non-`String` objects are rendered using their `toString` methods; if this parameter is `null`, the options are determined by the Look and Feel
      `initialValue` - the object that represents the default selection for the dialog; only meaningful if `options` is used; can be `null`
    Returns:
      an integer indicating the option chosen by the user, or `CLOSED_OPTION` if the user closed the dialog
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### createDialog

    public JDialog createDialog(Component parentComponent, String title) throws HeadlessException
    Creates and returns a new `JDialog` wrapping `this` centered on the `parentComponent` in the `parentComponent`'s frame. `title` is the title of the returned dialog. The returned `JDialog` will not be resizable by the user, however programs can invoke `setResizable` on the `JDialog` instance to change this property. The returned `JDialog` will be set up such that once it is closed, or the user clicks on one of the buttons, the optionpane's value property will be set accordingly and the dialog will be closed. Each time the dialog is made visible, it will reset the option pane's value property to `JOptionPane.UNINITIALIZED_VALUE` to ensure the user's subsequent action closes the dialog properly.
    Parameters:
      `parentComponent` - determines the frame in which the dialog is displayed; if the `parentComponent` has no `Frame`, a default `Frame` is used
      `title` - the title string for the dialog
    Returns:
      a new `JDialog` containing this instance
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### createDialog

    public JDialog createDialog(String title) throws HeadlessException
    Creates and returns a new parentless `JDialog` with the specified title. The returned `JDialog` will not be resizable by the user, however programs can invoke `setResizable` on the `JDialog` instance to change this property. The returned `JDialog` will be set up such that once it is closed, or the user clicks on one of the buttons, the optionpane's value property will be set accordingly and the dialog will be closed. Each time the dialog is made visible, it will reset the option pane's value property to `JOptionPane.UNINITIALIZED_VALUE` to ensure the user's subsequent action closes the dialog properly.
    Parameters:
      `title` - the title string for the dialog
    Returns:
      a new `JDialog` containing this instance
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    Since:
      1.6
    See Also:
      - `GraphicsEnvironment.isHeadless()`

  - ### showInternalMessageDialog

    public static void showInternalMessageDialog(Component parentComponent, Object message)
    Brings up an internal confirmation dialog panel. The dialog is a information-message dialog titled "Message".
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the object to display

  - ### showInternalMessageDialog

    public static void showInternalMessageDialog(Component parentComponent, Object message, String title, int messageType)
    Brings up an internal dialog panel that displays a message using a default icon determined by the `messageType` parameter.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`

  - ### showInternalMessageDialog

    public static void showInternalMessageDialog(Component parentComponent, Object message, String title, int messageType, Icon icon)
    Brings up an internal dialog panel displaying a message, specifying all parameters.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
      `title` - the title string for the dialog
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - an icon to display in the dialog that helps the user identify the kind of message that is being displayed

  - ### showInternalConfirmDialog

    public static int showInternalConfirmDialog(Component parentComponent, Object message)
    Brings up an internal dialog panel with the options Yes, No and Cancel; with the title, Select an Option.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the `Object` to display
    Returns:
      an integer indicating the option selected by the user

  - ### showInternalConfirmDialog

    public static int showInternalConfirmDialog(Component parentComponent, Object message, String title, int optionType)
    Brings up a internal dialog panel where the number of choices is determined by the `optionType` parameter.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the object to display in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string; other objects are converted to a `String` using the `toString` method
      `title` - the title string for the dialog
      `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
    Returns:
      an integer indicating the option selected by the user

  - ### showInternalConfirmDialog

    public static int showInternalConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType)
    Brings up an internal dialog panel where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display. The `messageType` parameter is primarily used to supply a default icon from the Look and Feel.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the object to display in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string; other objects are converted to a `String` using the `toString` method
      `title` - the title string for the dialog
      `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
      `messageType` - an integer designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    Returns:
      an integer indicating the option selected by the user

  - ### showInternalConfirmDialog

    public static int showInternalConfirmDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon)
    Brings up an internal dialog panel with a specified icon, where the number of choices is determined by the `optionType` parameter. The `messageType` parameter is primarily used to supply a default icon from the look and feel.
    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the parentComponent has no Frame, a default `Frame` is used
      `message` - the object to display in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string; other objects are converted to a `String` using the `toString` method
      `title` - the title string for the dialog
      `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`.
      `messageType` - an integer designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - the icon to display in the dialog
    Returns:
      an integer indicating the option selected by the user

  - ### showInternalOptionDialog

    public static int showInternalOptionDialog(Component parentComponent, Object message, String title, int optionType, int messageType, Icon icon, Object[] options, Object initialValue)
    Brings up an internal dialog panel with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

    If `optionType` is `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION` and the `options` parameter is `null`, then the options are supplied by the Look and Feel.

    The `messageType` parameter is primarily used to supply a default icon from the look and feel.

    Parameters:
      `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
      `message` - the object to display in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string. Other objects are converted to a `String` using the `toString` method
      `title` - the title string for the dialog
      `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
      `messageType` - an integer designating the kind of message this is; primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - the icon to display in the dialog
      `options` - an array of objects indicating the possible choices the user can make; if the objects are components, they are rendered properly; non-`String` objects are rendered using their `toString` methods; if this parameter is `null`, the options are determined by the Look and Feel
      `initialValue` - the object that represents the default selection for the dialog; only meaningful if `options` is used; can be `null`
    Returns:
      an integer indicating the option chosen by the user, or `CLOSED_OPTION` if the user closed the Dialog

  - ### showInternalInputDialog

    public static String showInternalInputDialog(Component parentComponent, Object message)
    Shows an internal question-message dialog requesting input from the user parented to `parentComponent`. The dialog is displayed in the `Component`'s frame, and is usually positioned below the `Component`.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
    Returns:
      user's input

  - ### showInternalInputDialog

    public static String showInternalInputDialog(Component parentComponent, Object message, String title, int messageType)
    Shows an internal dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
      `title` - the `String` to display in the dialog title bar
      `messageType` - the type of message that is to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE
    Returns:
      user's input

  - ### showInternalInputDialog

    public static Object showInternalInputDialog(Component parentComponent, Object message, String title, int messageType, Icon icon, Object[] selectionValues, Object initialSelectionValue)
    Prompts the user for input in a blocking internal dialog where the initial selection, possible selections, and all other options can be specified. The user will able to choose from `selectionValues`, where `null` implies the user can input whatever they wish, usually by means of a `JTextField`. `initialSelectionValue` is the initial value to prompt the user with. It is up to the UI to decide how best to represent the `selectionValues`, but usually a `JComboBox`, `JList`, or `JTextField` will be used.
    Parameters:
      `parentComponent` - the parent `Component` for the dialog
      `message` - the `Object` to display
      `title` - the `String` to display in the dialog title bar
      `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
      `icon` - the `Icon` image to display
      `selectionValues` - an array of `Objects` that gives the possible selections
      `initialSelectionValue` - the value used to initialize the input field
    Returns:
      user's input, or `null` meaning the user canceled the input

  - ### createInternalFrame

    public JInternalFrame createInternalFrame(Component parentComponent, String title)
    Creates and returns an instance of `JInternalFrame`. The internal frame is created with the specified title, and wrapping the `JOptionPane`. The returned `JInternalFrame` is added to the `JDesktopPane` ancestor of `parentComponent`, or components parent if one its ancestors isn't a `JDesktopPane`, or if `parentComponent` doesn't have a parent then a `RuntimeException` is thrown.
    Parameters:
      `parentComponent` - the parent `Component` for the internal frame
      `title` - the `String` to display in the frame's title bar
    Returns:
      a `JInternalFrame` containing a `JOptionPane`
    Throws:
      `RuntimeException` - if `parentComponent` does not have a valid parent

  - ### getFrameForComponent

    public static Frame getFrameForComponent(Component parentComponent) throws HeadlessException
    Returns the specified component's `Frame`.
    Parameters:
      `parentComponent` - the `Component` to check for a `Frame`
    Returns:
      the `Frame` that contains the component, or `getRootFrame` if the component is `null`, or does not have a valid `Frame` parent
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `getRootFrame()`
      - `GraphicsEnvironment.isHeadless()`

  - ### getDesktopPaneForComponent

    public static JDesktopPane getDesktopPaneForComponent(Component parentComponent)
    Returns the specified component's desktop pane.
    Parameters:
      `parentComponent` - the `Component` to check for a desktop
    Returns:
      the `JDesktopPane` that contains the component, or `null` if the component is `null` or does not have an ancestor that is a `JInternalFrame`

  - ### setRootFrame

    public static void setRootFrame(Frame newRootFrame)
    Sets the frame to use for class methods in which a frame is not provided.

    Note: It is recommended that rather than using this method you supply a valid parent.

    Parameters:
      `newRootFrame` - the default `Frame` to use

  - ### getRootFrame

    public static Frame getRootFrame() throws HeadlessException
    Returns the `Frame` to use for the class methods in which a frame is not provided.
    Returns:
      the default `Frame` to use
    Throws:
      `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
    See Also:
      - `setRootFrame(Frame)`
      - `GraphicsEnvironment.isHeadless()`

  - ### setUI

    @BeanProperty(hidden=true, description="The UI object that implements the optionpane's LookAndFeel") public void setUI(OptionPaneUI ui)
    Sets the UI object which implements the L&F for this component.
    Parameters:
      `ui` - the `OptionPaneUI` L&F object
    See Also:
      - `UIDefaults.getUI(JComponent)`

  - ### getUI

    public OptionPaneUI getUI()
    Returns the UI object which implements the L&F for this component.
    Overrides:
      `getUI` in class `JComponent`
    Returns:
      the `OptionPaneUI` object

  - ### updateUI

    public void updateUI()
    Notification from the `UIManager` that the L&F has changed. Replaces the current UI object with the latest version from the `UIManager`.
    Overrides:
      `updateUI` in class `JComponent`
    See Also:
      - `JComponent.updateUI()`

  - ### getUIClassID

    @BeanProperty(bound=false) public String getUIClassID()
    Returns the name of the UI class that implements the L&F for this component.
    Overrides:
      `getUIClassID` in class `JComponent`
    Returns:
      the string "OptionPaneUI"
    See Also:
      - `JComponent.getUIClassID()`
      - `UIDefaults.getUI(JComponent)`

  - ### setMessage

    @BeanProperty(preferred=true, description="The optionpane's message object.") public void setMessage(Object newMessage)
    Sets the option pane's message-object.
    Parameters:
      `newMessage` - the `Object` to display
    See Also:
      - `getMessage()`

  - ### getMessage

    public Object getMessage()
    Returns the message-object this pane displays.
    Returns:
      the `Object` that is displayed
    See Also:
      - `setMessage(Object)`

  - ### setIcon

    @BeanProperty(preferred=true, description="The option pane's type icon.") public void setIcon(Icon newIcon)
    Sets the icon to display. If non-`null`, the look and feel does not provide an icon.
    Parameters:
      `newIcon` - the `Icon` to display
    See Also:
      - `getIcon()`

  - ### getIcon

    public Icon getIcon()
    Returns the icon this pane displays.
    Returns:
      the `Icon` that is displayed
    See Also:
      - `setIcon(Icon)`

  - ### setValue

    @BeanProperty(preferred=true, description="The option pane's value object.") public void setValue(Object newValue)
    Sets the value the user has chosen.
    Parameters:
      `newValue` - the chosen value
    See Also:
      - `getValue()`

  - ### getValue

    public Object getValue()
    Returns the value the user has selected. `UNINITIALIZED_VALUE` implies the user has not yet made a choice, `null` means the user closed the window with out choosing anything. Otherwise the returned value will be one of the options defined in this object.
    Returns:
      the `Object` chosen by the user, `UNINITIALIZED_VALUE` if the user has not yet made a choice, or `null` if the user closed the window without making a choice
    See Also:
      - `setValue(Object)`

  - ### setOptions

    @BeanProperty(description="The option pane's options objects.") public void setOptions(Object[] newOptions)
    Sets the options this pane displays. If an element in `newOptions` is a `Component` it is added directly to the pane, otherwise a button is created for the element.
    Parameters:
      `newOptions` - an array of `Objects` that create the buttons the user can click on, or arbitrary `Components` to add to the pane
    See Also:
      - `getOptions()`

  - ### getOptions

    public Object[] getOptions()
    Returns the choices the user can make.
    Returns:
      the array of `Objects` that give the user's choices
    See Also:
      - `setOptions(Object[])`

  - ### setInitialValue

    @BeanProperty(preferred=true, description="The option pane's initial value object.") public void setInitialValue(Object newInitialValue)
    Sets the initial value that is to be enabled -- the `Component` that has the focus when the pane is initially displayed.
    Parameters:
      `newInitialValue` - the `Object` that gets the initial keyboard focus
    See Also:
      - `getInitialValue()`

  - ### getInitialValue

    public Object getInitialValue()
    Returns the initial value.
    Returns:
      the `Object` that gets the initial keyboard focus
    See Also:
      - `setInitialValue(Object)`

  - ### setMessageType

    @BeanProperty(preferred=true, description="The option pane's message type.") public void setMessageType(int newType)
    Sets the option pane's message type. The message type is used by the Look and Feel to determine the icon to display (if not supplied) as well as potentially how to lay out the `parentComponent`.
    Parameters:
      `newType` - an integer specifying the kind of message to display: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    Throws:
      `RuntimeException` - if `newType` is not one of the legal values listed above
    See Also:
      - `getMessageType()`

  - ### getMessageType

    public int getMessageType()
    Returns the message type.
    Returns:
      an integer specifying the message type
    See Also:
      - `setMessageType(int)`

  - ### setOptionType

    @BeanProperty(preferred=true, description="The option pane's option type.") public void setOptionType(int newType)
    Sets the options to display. The option type is used by the Look and Feel to determine what buttons to show (unless options are supplied).
    Parameters:
      `newType` - an integer specifying the options the L&F is to display: `DEFAULT_OPTION`, `YES_NO_OPTION`, `YES_NO_CANCEL_OPTION`, or `OK_CANCEL_OPTION`
    Throws:
      `RuntimeException` - if `newType` is not one of the legal values listed above
    See Also:
      - `getOptionType()`
      - `setOptions(Object[])`

  - ### getOptionType

    public int getOptionType()
    Returns the type of options that are displayed.
    Returns:
      an integer specifying the user-selectable options
    See Also:
      - `setOptionType(int)`

  - ### setSelectionValues

    @BeanProperty(description="The option pane's selection values.") public void setSelectionValues(Object[] newValues)
    Sets the input selection values for a pane that provides the user with a list of items to choose from. (The UI provides a widget for choosing one of the values.) A `null` value implies the user can input whatever they wish, usually by means of a `JTextField`.

    Sets `wantsInput` to true. Use `setInitialSelectionValue` to specify the initially-chosen value. After the pane as been enabled, `inputValue` is set to the value the user has selected.

    Parameters:
      `newValues` - an array of `Objects` the user to be displayed (usually in a list or combo-box) from which the user can make a selection
    See Also:
      - `setWantsInput(boolean)`
      - `setInitialSelectionValue(Object)`
      - `getSelectionValues()`

  - ### getSelectionValues

    public Object[] getSelectionValues()
    Returns the input selection values.
    Returns:
      the array of `Objects` the user can select
    See Also:
      - `setSelectionValues(Object[])`

  - ### setInitialSelectionValue

    @BeanProperty(description="The option pane's initial selection value object.") public void setInitialSelectionValue(Object newValue)
    Sets the input value that is initially displayed as selected to the user. Only used if `wantsInput` is true.
    Parameters:
      `newValue` - the initially selected value
    See Also:
      - `setSelectionValues(Object[])`
      - `getInitialSelectionValue()`

  - ### getInitialSelectionValue

    public Object getInitialSelectionValue()
    Returns the input value that is displayed as initially selected to the user.
    Returns:
      the initially selected value
    See Also:
      - `setInitialSelectionValue(Object)`
      - `setSelectionValues(Object[])`

  - ### setInputValue

    @BeanProperty(preferred=true, description="The option pane's input value object.") public void setInputValue(Object newValue)
    Sets the input value that was selected or input by the user. Only used if `wantsInput` is true. Note that this method is invoked internally by the option pane (in response to user action) and should generally not be called by client programs. To set the input value initially displayed as selected to the user, use `setInitialSelectionValue`.
    Parameters:
      `newValue` - the `Object` used to set the value that the user specified (usually in a text field)
    See Also:
      - `setSelectionValues(Object[])`
      - `setInitialSelectionValue(Object)`
      - `setWantsInput(boolean)`
      - `getInputValue()`

  - ### getInputValue

    public Object getInputValue()
    Returns the value the user has input, if `wantsInput` is true.
    Returns:
      the `Object` the user specified, if it was one of the objects, or a `String` if it was a value typed into a field
    See Also:
      - `setSelectionValues(Object[])`
      - `setWantsInput(boolean)`
      - `setInputValue(Object)`

  - ### getMaxCharactersPerLineCount

    @BeanProperty(bound=false) public int getMaxCharactersPerLineCount()
    Returns the maximum number of characters to place on a line in a message. Default is to return `Integer.MAX_VALUE`. The value can be changed by overriding this method in a subclass.
    Returns:
      an integer giving the maximum number of characters on a line

  - ### setWantsInput

    @BeanProperty(preferred=true, description="Flag which allows the user to input a value.") public void setWantsInput(boolean newValue)
    Sets the `wantsInput` property. If `newValue` is true, an input component (such as a text field or combo box) whose parent is `parentComponent` is provided to allow the user to input a value. If `getSelectionValues` returns a non-`null` array, the input value is one of the objects in that array. Otherwise the input value is whatever the user inputs.

    This is a bound property.

    Parameters:
      `newValue` - if true, an input component whose parent is `parentComponent` is provided to allow the user to input a value.
    See Also:
      - `setSelectionValues(Object[])`
      - `setInputValue(Object)`

  - ### getWantsInput

    public boolean getWantsInput()
    Returns the value of the `wantsInput` property.
    Returns:
      true if an input component will be provided
    See Also:
      - `setWantsInput(boolean)`

  - ### selectInitialValue

    public void selectInitialValue()
    Requests that the initial value be selected, which will set focus to the initial value. This method should be invoked after the window containing the option pane is made visible.

  - ### paramString

    protected String paramString()
    Returns a string representation of this `JOptionPane`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.
    Overrides:
      `paramString` in class `JComponent`
    Returns:
      a string representation of this `JOptionPane`

  - ### getAccessibleContext

    @BeanProperty(bound=false, expert=true, description="The AccessibleContext associated with this option pane") public AccessibleContext getAccessibleContext()
    Returns the `AccessibleContext` associated with this JOptionPane. For option panes, the `AccessibleContext` takes the form of an `AccessibleJOptionPane`. A new `AccessibleJOptionPane` instance is created if necessary.
    Specified by:
      `getAccessibleContext` in interface `Accessible`
    Overrides:
      `getAccessibleContext` in class `Component`
    Returns:
      an AccessibleJOptionPane that serves as the AccessibleContext of this AccessibleJOptionPane